summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--ChangeLog6
-rw-r--r--tests/misc/Makefile.am1
-rwxr-xr-xtests/misc/xstrtol69
3 files changed, 76 insertions, 0 deletions
diff --git a/ChangeLog b/ChangeLog
index 6c406e0bd..469ee29cb 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2007-08-04 Jim Meyering <jim@meyering.net>
+
+ Exercise xstrtol's diagnostics via pr's --pages option.
+ * tests/misc/xstrtol: New file.
+ * tests/misc/Makefile.am (TESTS): Add xstrtol.
+
2007-08-04 Paul Eggert <eggert@cs.ucla.edu>
Adapt to new human and xstrtol API.
diff --git a/tests/misc/Makefile.am b/tests/misc/Makefile.am
index 0aca4cf4c..8cf03f2a4 100644
--- a/tests/misc/Makefile.am
+++ b/tests/misc/Makefile.am
@@ -42,6 +42,7 @@ TESTS_ENVIRONMENT = \
# will execute the test script rather than the standard utility.
TESTS = \
+ xstrtol \
arch \
pr \
df-P \
diff --git a/tests/misc/xstrtol b/tests/misc/xstrtol
new file mode 100755
index 000000000..14f990c12
--- /dev/null
+++ b/tests/misc/xstrtol
@@ -0,0 +1,69 @@
+#!/bin/sh
+# exercise xstrtol's diagnostics via pr
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ pr --version
+fi
+
+. $srcdir/../envvar-check
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+exec $PERL -w -I$srcdir/.. -MCoreutils -- - <<\EOF
+require 5.003;
+use strict;
+
+(my $ME = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's output.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my $prog = 'pr';
+my $too_big = '9' x 81; # Big enough to overflow a 256-bit integer.
+my @Tests =
+ (
+ # test-name, [option, option, ...] {OUT=>"expected-output"}
+
+ ['inval-suffix', "--pages=${too_big}h", {EXIT => 1},
+ {ERR=>"$prog: invalid suffix in --pages argument `${too_big}h'\n"}],
+
+ ['too-big', "--pages=$too_big", {EXIT => 1},
+ {ERR=>"$prog: --pages argument `$too_big' too large\n"}],
+
+ ['simply-inval', "--pages=x", {EXIT => 1},
+ {ERR=>"$prog: invalid --pages argument `x'\n"}],
+
+ # FIXME: should be lower case "invalid".
+ ['inv-pg-range', "--pages=9x", {EXIT => 1},
+ {ERR=>"$prog: Invalid page range `9x'\n"}],
+ );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $fail = run_tests ($ME, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF